# 
# Exodus
# Copyright (C) 2014
#
# author: Natapol Pornputtapong <natapol.por@gmail.com>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#

# raise "Please, use ruby 1.9.0 or later." if RUBY_VERSION < "1.9.0"


$: << File.join(File.expand_path(File.dirname(__FILE__)))

#specify gem version
gem 'mongoid', '~> 3.1'

#Internal library
require 'open-uri'
require 'net/http'
require 'uri'
require 'json'
require 'csv'

#External library
#require 'bio-vcf'
require 'highline/import'
require 'mongoid'
require 'bio'
require 'pry'

I18n.enforce_available_locales = false

#library
require 'exodb/dbconnection.rb'
require 'exodb/usermanage.rb'
require 'exodb/datamodel.rb'
require 'exodb/exception.rb'
require 'exodb/constant.rb'
require 'exodb/utils.rb'
require 'exodb/addon.rb'

require 'exodb/extra.rb'

module Exodb
	
	@@verbose = true
	
	module_function
	
	def verbose()
		@@verbose = true
	end
	
	def noverbose()
		@@verbose = false
	end
	
	def putstv(str)
		putst(str) if @@verbose == true
	end
	
	def putst(str)
		puts "Exodb:STATUS #{str}"
	end
	
	def assembly(str)
		return Exodb::ASSEMBLY[str.downcase]
	end
end