# 
# Exodb
# Copyright (C) 2014
#
# author: Natapol Pornputtapong <natapol.por@gmail.com>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#

# raise "Please, use ruby 1.9.0 or later." if RUBY_VERSION < "1.9.0"


module Exodb
	
	class Region
		
		include Mongoid::Document
		include Mongoid::Timestamps
		
	end
	
	class Gene < Region
		
		include Mongoid::Versioning
		
		field :symbol,				type: String
		field :loh,					type: Boolean
		
		embeds_many :changes
		belongs_to :generef
		belongs_to :cell
		
		index({'symbol' => 1}, background: true)
		
	end
	
	class Change
		
		include Mongoid::Document
		include Mongoid::Timestamps
		
		embedded_in :gene
		has_many :variants
		
	end
	
	class Onexon < Change
		
		field :aaposition,			type: Integer # position referenced to the first codon from the longest splice variant
		field :refna,				type: String
		field :refaa,				type: String
		field :altna,				type: Hash
		field :inhna,				type: Hash
		field :isoform,				type: Array
		
		index({'aaposition' => 1}, background: true)
		
	end
	
	class Aa < Onexon
		
	end
	
	class Lossgain < Onexon
		
	end
	
	class Offexon < Change
		
	end
	
	class Splice < Offexon
		
	end
	
	class Utr < Offexon
		
	end
	
end