# 
# Exodb
# Copyright (C) 2014
#
# author: Natapol Pornputtapong <natapol.por@gmail.com>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#

# raise "Please, use ruby 1.9.0 or later." if RUBY_VERSION < "1.9.0"

module Exodb
    
	module XrefsField
		
		extend ActiveSupport::Concern
		
		included do
			
			field :xrefs,				type: Array
			
			index(xrefs: 1)
			
		end
		
		module ClassMethods
			
			def where_xrefs(str)
				return self.where({xrefs: str})
			end
			
		end
		
		# convert genomic position to codon position
		#
		# @param [String] namespace
		# @return [String] codon position
		def get_xref(ns = 'urn:miriam:refseq')
			xref = nil
			self[:xrefs].each {|e| xref = e if "urn:miriam:#{e.namespace}" == ns}
			return xref
		end
		
	end
	
end