# 
# Exodus
# Copyright (C) 2014
#
# author: Natapol Pornputtapong <natapol.por@gmail.com>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#

# raise "Please, use ruby 1.9.0 or later." if RUBY_VERSION < "1.9.0"


module Exodb

	class Mapping
		
		def self.load_assembly_mapping!(from, to)
			
			self.where(from: Exodb::assembly(from), to: Exodb::assembly(to))
			
			Exodb::Chrref.where({:assembly => Exodb::assembly(from), 'location.chr' => /\Achr/}).each do |chr|
				
				Exodb::Ensembl::REST.assembly_map(chr.locstr =~ /\Achr/ ? chr.locstr[3..-1] : chr.locstr,  Exodb::assembly(to),  Exodb::assembly(from))["mappings"].each do |map|
					
					#map = {"original"=>{"seq_region_name"=>"1", "strand"=>1, "coordinate_system"=>"chromosome", "end"=>235674528, "start"=>235669016, "assembly"=>"GRCh37"}, "mapped"=>{"seq_region_name"=>"1", "strand"=>1, "coordinate_system"=>"chromosome", "end"=>235511225, "start"=>235505713, "assembly"=>"GRCh38"}}
					
					mapping = self.new()
					mapping.chr = "#{map['original']["coordinate_system"] == "chromosome" ? 'chr' : ''}#{map['original']["seq_region_name"]}"
					mapping.start = map['original']["start"]
					mapping.stop = map['original']["end"]
					mapping.from = map['original']["assembly"]
					mapping.tchr = "#{map['mapped']["coordinate_system"] == "chromosome" ? 'chr' : ''}#{map['mapped']["seq_region_name"]}"
					mapping.tstart = map['mapped']["start"]
					mapping.tstop = map['mapped']["end"]
					mapping.coeff = map['mapped']["strand"]
					mapping.to = map['mapped']["assembly"]
					
					p mapping.save!
				end
			end
		end
	end
end