# 
# Exodb
# Copyright (C) 2014
#
# author: Natapol Pornputtapong <natapol.por@gmail.com>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#

# raise "Please, use ruby 1.9.0 or later." if RUBY_VERSION < "1.9.0"

require 'exodb/utils/upload_var.rb'
require 'exodb/utils/ensemblrest.rb'
require 'exodb/utils/miriamrest.rb'

#load script specific to rosiza project
require 'exodb/rositza.rb'

module Exodb
	
	module Utils
		
		module_function
		
		# Guess the type of id
		#
		# @param [String]  id string
		# @return [String] a miriam registry or the string itself incase cannot guess
		def guess_miriam(str)
			case str
			when /\A((AC|AP|NC|NG|NM|NP|NR|NT|NW|XM|XP|XR|YP|ZP)_\d+|(NZ\_[A-Z]{4}\d+))(\.\d+)?\z/
				return "urn:miriam:refseq:#{str}"
			when /\A((ENS[A-Z]*[FPTG]\d{11}(\.\d+)?)|(FB\w{2}\d{7})|(Y[A-Z]{2}\d{3}[a-zA-Z](\-[A-Z])?)|([A-Z_a-z0-9]+(\.)?(t)?(\d+)?([a-z])?))\z/
				return "urn:miriam:ensembl:#{str}"
			when /\A((HGNC|hgnc):)?\d{1,5}\z/
				return "urn:miriam:hgnc:#{str}"
			when /\ACCDS\d+\.\d+\z/
				return "urn:miriam:ccds:#{str}"
			else
				return str
			end
		end
		
	end
	
end